/*
ThingSpeak Demo with Microphone
for ESP32 DevKitC
Elektor / Jens Nickel
My Journey in the IoT
*/




#include "WiFi.h"


//
// WiFi network SSID and password
//

const char* ssid = "XXXXXXXX";
const char* password = "XXXXXXX";



//
// Thingspeak API key and host name
//

String APIKEY = "XXXXXXXXXX";
const char* host = "api.thingspeak.com";

int sample;

int sum_average;
int count_average;

int count_message;

int average;
int diff;
int treshold_pos = 10;
int treshold_neg = -10;

int sound_count;
long sound_total;




WiFiClient client;



// Connects the ESP32 DevKit C to the local WiFi network
void Connect_WiFi()
{
      WiFi.begin(ssid, password);
      while(WiFi.status() != WL_CONNECTED)
      {
        delay(1000);
      }
}



void setup() {
  
  Serial.begin(19200);
  
  Connect_WiFi();
  
  client.connect(host, 80);

  sum_average = 0;
  count_average = 0;

  average = 0;
  
  count_message = 0;

  sound_count = 0;
  sound_total = 0;

}




void loop() {
  // put your main code here, to run repeatedly:
  
   
  sample = analogRead(36);   // sample microphone signal

  sum_average += sample;     // sum up for average
  count_average += 1;

  if (average > 0)           // do not do this at start of program
  { 
    diff = sample - average;    // difference between current amplitude and average
  
    if (diff > treshold_pos || diff < treshold_neg)    // difference above threshold ?
    { 
        sound_count = sound_count + 1;    // big signal amplitude means high sound level
    }
  }
 
  if (count_average > 256)     // calculate new average every 256 samples
  {
    count_average = 0;
    
    average = sum_average >> 8;    // calculate new average
    sum_average = 0;   

    Serial.println(sound_count);

    sound_total += sound_count;    // sum up the high sound level counts
    sound_count = 0;

    count_message += 1;


    if (count_message > 2047)     // send out a message every 256 * 2048 samples
    {
      
      count_message = 0;
    
      client.connect(host,80);     // connect with ThingSpeak server

      // Send out HTTP GET to server, with API-KEY and sensor value
      client.print("GET /update?api_key=" + APIKEY + "&field1=");
      
      client.print(String(sound_total));
      
      client.print(" HTTP/1.0\r\n Host: https://api.thingspeak.com\r\n\r\n");

      sound_total = 0;
     
    }
    
  }
  
  //delay(1);
}
